; Started 32-bit kernel on August 21 2004
[BITS 32]
[ORG 1000h]	; Loaded at 1000h then copied to 100000h
jmp start

%include	"interrupts.asm"
%include	"pic.asm"
%include	"keyboard.asm"
%include	"console.asm"
%include	"video.asm"
%include	"syscall.asm"

start:
mov bl,07h
call ClearScr

mov esi,LoadMsg
call PrintPMode

mov esi,PICMsg
call PrintPMode
call Init_PIC
mov esi,PICOk
call PrintPMode

;mov esi,KeybMsg
;call PrintPMode
;call Init_Keyboard
;mov esi,KeybOk
;call PrintPMode

lidt [idt_desc]
sti

xor al,al
mov esi,LoadOk
int 30h

mov al,0Dh
call putc

xor al,al		; call the RooOS
mov esi,Prompt	; print function
int 30h		;

@cmdloop:
	mov al,1		; call the RooOs getch
	int 30h		; function

	cmp al,KEY_ENTER
	je Cmd

	cmp al,KEY_BACKSPACE
	je @cl_1

	or al,al
	je @cmdloop
	
	mov edx,[CursorPos]
	mov [CmdBuffer+edx],al

	inc dword [CursorPos]
@cl_1:call putc
	jmp @cmdloop
Cmd:
	call putc
	mov dword[CursorPos],0
	mov esi,CmdList
	xor eax,eax
	xor ecx,ecx
	xor ebx,ebx
FindCmd:
	mov edi,CmdBuffer
	mov al,byte[edi]
	test al,al
	je ClearBuff
	lodsb
	test al,al
	je BadCmd
	mov cl,al
	push esi
	repe cmpsb
	je FindAddr
	pop esi

	add esi,eax
	inc ebx
	jmp FindCmd
FindAddr:
	cmp byte[edi],0
	jne BadCmd
	shl ebx,2
	mov esi,CmdAddr
	add esi,ebx
	mov esi,[esi]
	jmp esi
;	add ebx,CmdAddr
;	mov esi,[ebx]

BadCmd:
	xor eax,eax
	mov esi,BadCommand
	int 30h
ClearBuff:
	xor al,al		; call the RooOS
	mov esi,Prompt	; print function
	int 30h		;

	mov edi,CmdBuffer
	mov ecx,100h
	xor eax,eax
	rep stosd
	jmp @cmdloop

SayHello:
;	mov esi,NameMsg
;	xor eax,eax
;	int 30h
;
;	mov edi,buff
;	mov ecx,100	
;	mov eax,2	; call the getStr function
;	int 30h
;
	xor eax,eax
	mov esi,HelloMsg
	int 30h
;	xor eax,eax
;	mov esi,buff
;	int 30h
;	mov al,0Dh
;	call putc
	jmp ClearBuff

ShowHelp:
	xor eax,eax
	mov esi,HelpMsg
	int 30h
	jmp ClearBuff

ClrScr:
	mov al,3
	int 30h
	jmp ClearBuff

Shutdown:
	xor eax,eax
	mov esi,ShutMsg
	int 30h

;	mov ecx,50
;@dotloop:
;	mov esi,Dot
;	xor eax,eax
;	int 30h
;	dec ecx
;	jne @dotloop
;
;	mov al,0Dh
;	call putc

	mov esi,PowerMsg
	int 30h

	cli
	hlt
	jmp short $
Reboot:
	call kbd	; empty keyboard buffer
	mov al,0FEh	; 8042 command byte to pulse Output Port pin
	out 64h,al
	cli
	hlt
	jmp short $

Timer:
	cli
	pushad
	push ds
	push es

	inc dword[Ticks]
	mov byte[ds:0B8000h],'R'
	mov eax,[Ticks]
	mov byte[ds:0B8001h],al

	mov al,20h
	out 20h,al	; Send EOI (End of Interrupt)

	pop es
	pop ds
	popad
	iret

Prompt	db 0Eh,"Roo:-> ",0
BadCommand	db 0Eh,"Bad Command entered",0Dh,0

NameMsg	db 0Eh,"What is your name? ",0
HelloMsg	db 0Eh,"Hello to you!!",0Dh,0

LoadMsg	db 0Eh,"RooOS Kernel is loading......",0Dh,0
LoadOk	db 0Eh,"RooOs Kernel Loaded",0Dh,0

PICMsg	db 0Eh,"Initalizing PIC.....",0Dh,0
PICOk		db 0Eh,"PIC reprogrammed successfully",0Dh,0

;KeybMsg	db 0Eh,"Initializing Keyboard.....",0Dh,0
;KeybOk	db 0Eh,"Keyboard initalized successfully",0Dh,0

ShutMsg	db 0Eh,"Shutting down system.....",0Dh,0
PowerMsg	db 0Eh,"You can now turn off the system",0

HelpMsg	db 0Eh,"You can use the following commands:",
		db 0Dh,
		db 0Dh,"hello     :     Says hello to you",
		db 0Dh,"cls       :     Clears the screen",
		db 0Dh,"reboot    :     Reboots the system"
		db 0Dh,0
;		db 0Dh,"
;		db 0Dh,"

Dot		db 0Eh,".",0

CmdList	db 5,"hello",6,"reboot",8,"shutdown",3,"cls",4,"help",0
CmdAddr	dd SayHello,Reboot,Shutdown,ClrScr,ShowHelp,0

TextPtr	dd 0
Ticks		dd 0

CmdBuffer	times 256 db 0
CursorPos	dd 0
buff	times	100 db 0
