[BITS 32]
Interrupt_00h:
	pushad
	push es
	push ds
	mov eax,12
	mov ebx,22
	call GoToXY
	mov esi,Err_Div0
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_01h:
	pushad
	push es
	push ds
	mov esi,Err_Debug
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_02h:
	pushad
	push es
	push ds
	mov esi,Err_NMI
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_03h:
	pushad
	push es
	push ds
	mov esi,Err_BreakPt
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_04h:
	pushad
	push es
	push ds
	mov esi,Err_OverFlw
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_05h:
	pushad
	push es
	push ds
	mov esi,Err_Bound
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_06h:
	pushad
	push es
	push ds
	mov bl,27h
	call ClearScr
	mov esi,Err_BadOp
	call PrintPMode
	jmp short $
	pop ds
	pop es
	popad
	iret
Interrupt_07h:
	pushad
	push es
	push ds
	mov esi,Err_NoCoPro
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_08h:
	pushad
	push es
	push ds
	mov bl,27h
	call ClearScr
	mov eax,12
	mov ebx,22
	call GoToXY
	mov esi,Err_DblFlt
	call PrintPMode
	jmp short $
	pop ds
	pop es
	popad
	iret
Interrupt_09h:
	pushad
	push es
	push ds
	mov esi,Err_CoPrOvr
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_0Ah:
	pushad
	push es
	push ds
	mov bl,27h
	call ClearScr
	mov eax,12
	mov ebx,22
	call GoToXY
	mov esi,Err_BadTSS
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_0Bh:
	pushad
	push es
	push ds
	mov esi,Err_NoSeg
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_0Ch:
	pushad
	push es
	push ds
	mov bl,27h
	call ClearScr
	mov esi,Err_StackEx
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_0Dh:
	pushad
	push es
	push ds
	mov bl,27h
	call ClearScr
	mov eax,12
	mov ebx,22
	call GoToXY
	mov esi,Err_GPF
	call PrintPMode
	jmp short $
	pop ds
	pop es
	popad
	iret
Interrupt_0Eh:
	pushad
	push es
	push ds
	mov bl,27h
	call ClearScr
	mov eax,12
	mov ebx,22
	call GoToXY
	mov esi,Err_PageFlt
	call PrintPMode
	jmp short $
	pop ds
	pop es
	popad
	iret
Interrupt_10h:
	pushad
	push es
	push ds
	mov esi,Err_CoProc
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_11h:
	pushad
	push es
	push ds
	mov esi,Err_AlgnChk
	call PrintPMode
	pop ds
	pop es
	popad
	iret
Interrupt_12h:
	pushad
	push es
	push ds
	mov esi,Err_MachChk
	call PrintPMode
	jmp short $
	pop ds
	pop es
	popad
	iret
Interrupt_13h:
	pushad
	push es
	push ds
	mov esi,Err_Bah
	call PrintPMode
	pop ds
	pop es
	popad
	iret
irq:
	pushadd
	push es
	push ds

	mov byte[ds:0B8008h],'I'
	mov byte[ds:0B8009h],0Ah
	mov byte[ds:0B800Ah],'R'
	mov byte[ds:0B800Bh],0Ah
	mov byte[ds:0B800Ch],'Q'
	mov byte[ds:0B800Dh],0Ah

	mov al,20h
	out 20h,al	; Send EOI (End of Interrupt)
	out 0A0h,al

	pop ds
	pop es
	popad
	iretd

idt:
int_00h:
	dw Interrupt_00h	; offset 15:0
	dw 08h		; selector
	db 0			; (always 0 for interrupt gates)
	db 10001110b	; present,ring 0,'386 interrupt gate
	dw 0			; offset 31:16
int_01h:
	dw Interrupt_01h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_02h:
	dw Interrupt_02h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_03h:
	dw Interrupt_03h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_04h:
	dw Interrupt_04h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_05h:
	dw Interrupt_05h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_06h:
	dw Interrupt_06h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_07h:
	dw Interrupt_07h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_08h:
	dw Interrupt_08h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_09h:
	dw Interrupt_09h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_0Ah:
	dw Interrupt_0Ah
	dw 08h
	db 0
	db 10001110b
	dw 0
int_0Bh:
	dw Interrupt_0Bh
	dw 08h
	db 0
	db 10001110b
	dw 0
int_0Ch:
	dw Interrupt_0Ch
	dw 08h
	db 0
	db 10001110b
	dw 0
int_0Dh:
	dw Interrupt_0Dh
	dw 08h
	db 0
	db 10001110b
	dw 0
int_0Eh:
	dw Interrupt_0Eh
	dw 08h
	db 0
	db 10001110b
	dw 0
int_0Fh:	; Reserved by INTEL
	dw 0
	dw 0
	db 0
	db 10001110b
	dw 0
int_10h:
	dw Interrupt_10h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_11h:
	dw Interrupt_11h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_12h:
	dw Interrupt_12h
	dw 08h
	db 0
	db 10001110b
	dw 0
int_13h:
	dw Interrupt_13h
	dw 08h
	db 0
	db 10001110b
	dw 0

%rep 12	; reserved by intel 20 - 31
	dw 0
	dw 0
	db 0
	db 10001110b
	dw 0
%endrep

int_20h:	; timer (IRQ 0)
	dw Timer
	dw 08h
	db 0
	db 10001110b
	dw 0

int_21h:	; keyboard (IRQ 1)
	dw Keyboard
	dw 08h
	db 0
	db 10001110b
	dw 0
%rep 14	; rest are unprocessed IRQs
	dw irq
	dw 08h
	db 0
	db 10001110b
	dw 0
%endrep

int_30h:
	dw Syscall_Handler
	dw 08h
	db 0
	db 10001110b
	dw 0
idt_end:

idt_desc:	dw idt_end-idt-1
		dd idt
Err_Div0	db 20h,"Integer Divide by Zero Exception",0
Err_Debug	db 20h,"Debug Exception!!",0
Err_NMI	db 20h,"NMI Interrupt Occured!!",0
Err_BreakPt	db 20h,"Breakpoint encountered!!",0
Err_OverFlw	db 20h,"OverFlow!!",0
Err_Bound	db 20h,"Bounds Check",0
Err_BadOp	db 20h,"Invalid Opcode!!",0
Err_NoCoPro	db 20h,"CoProcessor not available!!",0
Err_DblFlt	db 20h,"Double Fault!!",0
Err_CoPrOvr	db 20h,"Coprocessor Segment Overrun!!",0
Err_BadTSS	db 20h,"Invalid TSS!!",0
Err_NoSeg	db 20h,"Segment not Present!!",0
Err_StackEx	db 20h,"Stack Exception",0
Err_GPF	db 20h,"General Protection Fault!!!",0
Err_PageFlt	db 20h,"Page Fault!!",0
Err_CoProc	db 20h,"Coprocessor Error!!",0
Err_AlgnChk	db 20h,"Align Check!!",0
Err_MachChk	db 20h,"Machine Check!!",0
Err_Bah	db 20h,"BAH SIMD!!",0
