[BITS 32]
PrintPMode:
	cld
	push ecx
	push eax
	mov edi,0B8000h
	mov edx,[TextPtr]
	shl edx,1
	add edi,edx
	mov ah,[ds:esi]	; Get text attributes
	inc esi
	strloop:
		mov al,[ds:esi]
		test al,al
		je endstr
		inc esi		; faster than lodsb
		cmp al,KEY_ENTER
		je _CR
	put:	mov word [es:edi],ax
		inc dword [TextPtr]
		add edi,2
		jmp strloop
	_CR:	call PutCR
		mov eax,[TextPtr]
		shl eax,1
		mov edi,0B8000h
		add edi,eax
		jmp strloop
	endstr:
	call MoveCursor
	pop eax
	pop ecx
	ret
putc:
	mov edi,0B8000h
	mov edx,[TextPtr]
	shl edx,1
	add edi,edx
	cmp al,0Dh		; enter
	je @p_cr
	cmp al,KEY_BACKSPACE		; backspace
	je @p_bk
	mov ah,0Eh
	mov word [edi],ax
	inc dword [TextPtr]
	jmp @p_exit
@p_cr:
	call PutCR
	jmp @p_exit
@p_bk:
	call PutBkSpace
@p_exit:
	ret

GoToXY:	; eax = row, ebx = col, pos = 2*(row*80+col)
	mov ecx,eax	; take another copy in ecx
	shl eax,6	; multiply eax by 64
	shl ecx,4	; multiply ecx by 16
	add eax,ecx	; add both together to get row * 80 as 64 +16 = 80
	add eax,ebx	; add col no.
	inc eax
	mov [TextPtr],eax
	call MoveCursor
	ret

ClearScr:
	cld
	mov edi,0B8000h
	xor ecx,ecx
	mov al," "
	mov ah,bl
	clrloop:
		cmp ecx,2000
		je endcloop
		inc ecx
		mov word [ds:edi],ax
		add edi,2
		jmp clrloop
	endcloop:
	mov dword [TextPtr],0
	ret
MoveCursor:
	push ax
	push cx
	push dx

	mov cx,[TextPtr]
	mov bx,cx		; save it in bx

	mov dx,03D4h
	mov ax,14
	out dx,ax	; out 03D4h,14

	inc dx
	shr bx,8
	mov ax,bx
	out dx,ax	; out 03D5h,(TextPtr >> 8)

	dec dx
	mov ax,15
	out dx,ax	; out 03D4h,15

	inc dx
	mov ax,cx
	out dx,ax	; out 03D5h,TextPtr

	pop dx
	pop cx
	pop ax
	ret

PutCR:
	push eax	; save all the regs
	push edx
	push ecx
	mov eax,[TextPtr]	; get current VGA CursorPos
	xor edx,edx		; zero edx
	mov ecx,80		; divide the cursur pos by 80
	push ecx
	div ecx		;
	pop ecx
	sub ecx,edx
	add [TextPtr],ecx	; add the remainder to current pos
	mov eax,[TextPtr]
	call MoveCursor
	pop ecx
	pop edx
	pop eax
	ret

PutBkSpace:
	cmp dword[CursorPos],0
	je @bk_x

	dec dword[CursorPos]
	dec dword[TextPtr]

	mov edx,[CursorPos]
	mov byte[CmdBuffer+edx],0

	mov edi,0B8000h
	mov edx,[TextPtr]
	shl edx,1
	add edi,edx
	mov word[edi],0E20h

@bk_x:ret
